DWARF_ADD_AT_STRING(3) | Library Functions Manual | DWARF_ADD_AT_STRING(3)

# NAME

`dwarf_add_AT_string` — create and attach a string class attribute

# LIBRARY

DWARF Access Library (libdwarf, -ldwarf)

# SYNOPSIS

`#include <libdwarf.h>`

Dwarf_P_Attribute
`dwarf_add_AT_string`(Dwarf_P_Debug dbg, Dwarf_P_Die die, Dwarf_Half attr, char *str, Dwarf_Error *err);

# DESCRIPTION

Function `dwarf_add_AT_string`() creates an attribute descriptor belonging to the ‘string’ class and attaches it to the debugging information entry referenced by argument die. The created attribute descriptor will have DWARF form `DW_FORM_strp`.

Argument dbg should reference a DWARF producer instance allocated using dwarf_producer_init(3) or dwarf_producer_init_b(3).

Argument die should reference a debugging information entry allocated using dwarf_new_die(3).

Argument attr should specify the attribute code for the created attribute descriptor.

Argument str should hold a pointer to a NUL-terminated string which will become the value of the created attribute descriptor.

If argument err is not `NULL`, it will be used to store error information in case of an error.

# RETURN VALUES

On success, function `dwarf_add_AT_string`() returns the created attribute descriptor. In case of an error, function `dwarf_add_AT_string`() returns `DW_DLV_BADADDR` and sets the argument err.

# ERRORS

Function `dwarf_add_AT_string`() can fail with:

[`DW_DLE_ARGUMENT`]
  One of the arguments dbg, die or str was `NULL`.
[`DW_DLE_MEMORY`]
  An out of memory condition was encountered during the execution of the function.

# SEE ALSO

dwarf(3), dwarf_add_AT_const_value_string(3), dwarf_add_AT_name(3), dwarf_new_die(3), dwarf_producer_init(3), dwarf_producer_init_b(3)

September 4, 2011 | NetBSD 11.0